import { Image } from 'itk-wasm';
import MorphologicalContourInterpolationNodeOptions from './morphological-contour-interpolation-node-options.js';
import MorphologicalContourInterpolationNodeResult from './morphological-contour-interpolation-node-result.js';
/**
 * Interpolates contours between slices.
 *
 * @param {Image} inputImage - The input image
 * @param {MorphologicalContourInterpolationNodeOptions} options - options object
 *
 * @returns {Promise<MorphologicalContourInterpolationNodeResult>} - result object
 */
declare function morphologicalContourInterpolationNode(inputImage: Image, options?: MorphologicalContourInterpolationNodeOptions): Promise<MorphologicalContourInterpolationNodeResult>;
export default morphologicalContourInterpolationNode;
