import { Image } from 'itk-wasm';
import MorphologicalContourInterpolationOptions from './morphological-contour-interpolation-options.js';
import MorphologicalContourInterpolationResult from './morphological-contour-interpolation-result.js';
/**
 * Interpolates contours between slices.
 *
 * @param {Image} inputImage - The input image
 * @param {MorphologicalContourInterpolationOptions} options - options object
 *
 * @returns {Promise<MorphologicalContourInterpolationResult>} - result object
 */
declare function morphologicalContourInterpolation(inputImage: Image, options?: MorphologicalContourInterpolationOptions): Promise<MorphologicalContourInterpolationResult>;
export default morphologicalContourInterpolation;
